import { DomainEventClass } from '../types/domain-event.type';
import 'reflect-metadata';
export interface DomainEventMetadata {
    eventType: string;
    aggregateType: string;
}
export declare class DomainEvent<P> {
    readonly metadata: Readonly<DomainEventMetadata>;
    readonly id: string;
    readonly aggregateId: string;
    readonly timestamp: number;
    readonly props: Readonly<P>;
    constructor(metadata: DomainEventMetadata, id: string, aggregateId: string, timestamp: number, props: P);
    static newEvent<T extends AnyDomainEvent>(this: DomainEventClass<T>, aggregateId: string, props: GetDomainEventProps<T>, id?: string): T;
}
export type AnyDomainEvent = DomainEvent<any>;
export type GetDomainEventProps<T extends AnyDomainEvent> = T extends DomainEvent<infer P> ? P : never;
export type DomainEventConstructorParamsWithProps<Props> = ConstructorParameters<typeof DomainEvent<Props>>;
export type DomainEventConstructorParams<T extends AnyDomainEvent> = DomainEventConstructorParamsWithProps<GetDomainEventProps<T>>;
