"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DomainEvent = void 0;
const decorators_1 = require("src/decorators");
const uuid_1 = require("uuid");
require("reflect-metadata");
class DomainEvent {
    constructor(metadata, id, aggregateId, timestamp, props) {
        this.metadata = metadata;
        this.id = id;
        this.aggregateId = aggregateId;
        this.timestamp = timestamp;
        this.props = props;
    }
    static newEvent(aggregateId, props, id = (0, uuid_1.v4)()) {
        const metadata = Reflect.getMetadata(decorators_1.DOMAIN_EVENT_METADATA, this);
        return new this(metadata, id, aggregateId, Date.now(), props);
    }
}
exports.DomainEvent = DomainEvent;
