import { EnumerationClass } from '../types/enumeration.type';
import 'reflect-metadata';
export type EnumerationValue = string | number;
export type EnumerationGenerator<T extends Enumeration> = {
    (): T;
    _isEnumGenerator: boolean;
    _enum?: T;
};
export declare class Enumeration {
    private readonly _type;
    private readonly _value;
    constructor(type: string, value: EnumerationValue);
    static newEnum<T extends AnyEnumeration>(this: EnumerationClass<T>, value: EnumerationValue): EnumerationGenerator<T>;
    static parseEnum<T extends AnyEnumeration>(this: EnumerationClass<T>, value: EnumerationValue): T | undefined;
    static allEnums<T extends AnyEnumeration>(this: EnumerationClass<T>): T[];
    get type(): string;
    get value(): EnumerationValue;
}
export type AnyEnumeration = Enumeration;
export type EnumerationConstructorParams = ConstructorParameters<typeof Enumeration>;
