"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Enumeration = void 0;
const decorators_1 = require("src/decorators");
require("reflect-metadata");
class Enumeration {
    constructor(type, value) {
        this._type = type;
        this._value = value;
    }
    static newEnum(value) {
        const enumClass = this;
        let _enum;
        function generator() {
            if (!_enum) {
                const enumerationType = Reflect.getMetadata(decorators_1.ENUMERATION_TYPE, enumClass);
                _enum = new enumClass(enumerationType, value);
            }
            return _enum;
        }
        generator._enum = _enum;
        generator._isEnumGenerator = true;
        return generator;
    }
    static parseEnum(value) {
        return this.allEnums().find((instance) => instance.value === value);
    }
    static allEnums() {
        const properties = Object.keys(this);
        return properties
            .map((name) => this[name])
            .filter((value) => typeof value === 'function' && (value === null || value === void 0 ? void 0 : value._isEnumGenerator))
            .map((generator) => generator());
    }
    get type() {
        return this._type;
    }
    get value() {
        return this._value;
    }
}
exports.Enumeration = Enumeration;
