import { Aggregate } from '../core/aggregate';
import { AccountStatus } from './account-status';
import { Password } from './password';
export type AccountProps = {
    username: string;
    password: Password;
    status: AccountStatus;
};
export type CreateAccountProps = Omit<AccountProps, 'status'>;
export declare class Account extends Aggregate<AccountProps> {
    validateProps(props: AccountProps): void;
    static create(props: CreateAccountProps): Account;
    get username(): string;
    get password(): Password;
    get status(): AccountStatus;
}
