"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Account = void 0;
const aggregate_1 = require("../core/aggregate");
const decorators_1 = require("src/decorators");
const account_created_event_1 = require("./account-created.event");
const account_status_1 = require("./account-status");
let Account = exports.Account = class Account extends aggregate_1.Aggregate {
    validateProps(props) { }
    static create(props) {
        const newAccount = this.initAggregate(Object.assign(Object.assign({}, props), { status: account_status_1.AccountStatus.ActivatePending() }));
        const event = account_created_event_1.AccountCreatedEvent.newEvent(newAccount.id, {
            accountId: newAccount.id,
            username: newAccount.username,
        });
        console.log(event);
        newAccount.recordEvent(event);
        return newAccount;
    }
    get username() {
        return this._props.username;
    }
    get password() {
        return this._props.password;
    }
    get status() {
        return this._props.status;
    }
};
exports.Account = Account = __decorate([
    (0, decorators_1.AggregateType)()
], Account);
